#!/bin/bash
##########################################
# File Name:35_check_web_date.sh
# Version:V1.0
# Author:zhangpeng
# 0rganization:linuxjk.cn
# Desc:案例35：检查域名是否过期 
#func
source /funcs/func_diy.sh
###########################################
#1 vars
#url=linuxjk.cn
#用下面的whois命令取出域名过期时间
# whois linuxjk.cn | egrep -i "(expiry date)|(expiration time)" | awk '{print $(NF-1),$NF}'
export LANG=en_US.UTF-8
url="$1"
if [ -z "$url" ]; then
  read -p "请输入域名（如 xxx.com）: " url
fi
#2.检查参数是否为空
if [ -z "$url" ];then
	redecho "Help: sh $0 *.com/cn..."
	exit 1
fi
#取出当前的日期和域名过期日期
date_now=$(date "+%F %T")
date_check=$(whois "$url" 2>/dev/null | egrep -i "(expiry date)|(expiration time)" | awk -F'e: ' '{print $NF}')
if [ -z "$date_check" ]; then
  redecho "无法获取域名 $url 的到期时间"
  exit 2
fi
#3.用date +%s -d将两个日期都转化为秒
date_now_second=$(date +%s -d "$date_now")
date_check_second=$(date +%s -d "$date_check")

#4.测试是否成功转化为秒，此处如果有负数或空值说明转化失败
#echo $date_now_second
#echo $date_check_second


#5.用 awk/bc计算两个日期之间的差值（单位秒）
diff_second=$(awk -v a=$date_now_second -v b=$date_check_second 'BEGIN{print b-a}')
#6.差值转化为天
diff_day=$(awk -v a=$diff_second 'BEGIN{print a/60/60/24}')
diff_month=$(awk -v a=$diff_second 'BEGIN{print a/60/60/24/30}')
diff_year=$(awk -v a=$diff_second 'BEGIN{print a/60/60/24/30/12}')
#7.输出信息
#echo "$url have $diff_day day, =$diff_month month, = $diff_year year"
#if [ $diff_day -ge 60 ];then
if (( $(echo "$diff_day >= 60" | bc -l) )); then
	greenecho "域名$url  还有$diff_day 天到期, 还有 $diff_month月到期, 还有$diff_year年到期"
else
	redecho "请及时续费;"
	redecho "域名$url  还有$diff_day 天到期, 还有 $diff_month月到期, 还有$diff_year年到期"
fi
